unit UnitData;

interface

uses
   UnitFunc ;

const
   LAYER_MAX_NUM = 256 ;   // Cő吔
   COLOR_MAX_NUM = 256 ;   // F@ő吔
   LTYPE_MAX_NUM =  32 ;   // ő吔
   WIDTH_MAX_NUM =  16 ;   // ő吔
   MFONT_MAX_NUM =1024 ;   // tHgő吔

type
   TZumenTitle = record       // }ʏb}ʕ\藓
      P_Name : string ;       // Ɩ
      C_Name : string ;       // H
      C_type : string ;       // _敪
      D_title : string ;      // }ʖ
      D_number : string ;     // }ʔԍ
                              // }ʔԍ + $$ + }ʐō\B$$ȍ~̓IvV
      D_type : string ;       // }ʎ
      D_Scale : string ;      // ړx
      D_Year : integer ;      // }ʍ쐬Nij
      D_Month : integer ;     // V     112
      D_Day : integer ;       // V     131
      C_Contractor : string ; // 󒍉Ж
      C_Owner : string ;      // ƎҖ
   end;

   TZumenPaper = record       // }ʍ\bp
      name : string ;         // }ʖ
      typ : integer ;         // pTCY(0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
      orient : integer;       // c^敪(0:c,1:)
      x : integer ;           // Rp(Pmm)
      y : integer ;           // Rpc(Pmm)
   end;

   TZumenLayer = record       // }ʍ\bC
      name  : string ;        // C
      Lflag : Integer ;       // 0:\ 1:\
      Color : Integer ;       // CF
      Ltype : Integer ;       // C
      Width : Integer ;       // C
      Mfont : Integer ;       // CtHg
      cnt   : Integer ;       // Cvf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenColor = record       // }ʍ\bF
      Red   : Integer ;       // ql
      Green : Integer ;       // fl
      Blue  : Integer ;       // al
      cnt   : Integer ;       // Fvf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenLtype = record       // }ʍ\b
      name  : string ;        // 햼
      Segment : Integer ;     // ZOg `F0,2,4,8,10@[U`F2,4,6,8
      Pitch : array[0..9] of double ;  // esb`
      SpaceMax : double ;     // ]ősb`
      cnt   : Integer ;       // vf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenWidth = record       // }ʍ\b
      Width : double ;        // 
      cnt   : Integer ;       // vf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenFont = record        // }ʍ\btHg
      name  : string ;        // tHg
      cnt   : Integer ;       // tHgvf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TDataOrder = record        // f[^}
      DataType : Integer ;    // f[^^Cv (1:_}[J 2: 3:ܐ...)
      DataNo	: Integer ;    // f[^vfNo (0-)
   end;

   TDataTenMarker = record    // 􉽗vf^\Lvfb_}[J
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@1`256)
      start_x : double ;      // zu_wW
      start_y : double ;      // zu_xW
      marker_code : Integer ; // }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
      rotate_angle : double ; // ]p[]
      Scale : double ;        // ړx
   end;

   TDataLine = record         // 􉽗vf^\Lvfb
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      start_x : double ;      // n_wW
      start_y : double ;      // n_xW
      end_x : double ;        // I_wW
      end_y : double ;        // I_xW
   end;

   TDataLines = record        // 􉽗vf^\Lvfbܐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataCircle = record       // 􉽗vf^\Lvfb~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius : double ;       // a
   end;

   TDataArc = record          // 􉽗vf^\Lvfb~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius : double ;       // a
      Direction : Integer ;   // @(0:v,1:v)
      start_angle : double ;  // np[]
      end_angle : double ;    // Ip[]
   end;

   TDataEllipse = record      // 􉽗vf^\Lvfbȉ~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius_x : double ;     // wa
      Radius_y : double ;     // xa
      rotation_angle:double ; // ]p[]
   end;

   TDataEllipseArc = record   // 􉽗vf^\Lvfbȉ~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius_x : double ;     // wa
      Radius_y : double ;     // xa
      Direction: Integer ;    // @(0:v,1:v)
      rotation_angle:double ; // ]p[]
      start_angle : double ;  // np[]
      end_angle   : double ;  // Ip[]
   end;

   TDataText = record         // 􉽗vf^\Lvfb
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F       (0:CF@ 1`256)
      Font  : Integer ;       // tHg (0:CtHg 1`1024)
      str   : string ;        //    (ő256oCg)
      text_x: double ;        // zu_wW
      text_y: double ;        // zu_xW
      Height: double ;        // ͈͍
      Width : double ;        // ͈͕
      Spc   : double ;        // Ԋu
      Angle : double ;        // ]p[]
      Slant : double ;        // Xgp[]
      b_pnt : Integer ;       // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct: Integer ;       // oi1:, 2:cj
   end;

   TDataBezier = record       // 􉽗vf^\LvfbXvCixWFȐj
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      open_close : Integer ;  // J敪F0: 1:J
      sep : Integer ;         // _ԕ (1`1000)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataBspline = record      // Ǝb􉽗vf^\LvfbaXvCȐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      open_close : Integer ;  // J敪F0: 1:J
      sep : Integer ;         // _ԕ (1`1000)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataSpline = record       // Ǝb􉽗vf^\LvfbXvCȐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Stype : Integer ;       // Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
      Aval  : double ;        // CXvĈ`l(0-1 ʏ0.5)
      open_close : Integer ;  // J敪F0: 1:J
      sep : Integer ;         // _ԕ (1`1000)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataClothoid = record       // 􉽗vf^\LvfbN\ChȐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      base_x: double ;        // zu_wW
      base_y: double ;        // zu_xW
      Aval  : double ;        // p[^@N\Cĥ`l (0)
      Direction: Integer ;    // @(0:v,1:v)
      Angle : double ;        // ]p[]
      start_length : double ; // JnȐ (0ȏ)
      end_length : double ;   // IȐ (0ȏ)
      sep : Integer ;         //  (1`10000)
   end;

   TDataSymbolZukei = record  // \vfbV{}`zu
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(0:`Ȃ 1`256)
      color_flag : Integer ;  // FR[htO(0: 1:L)
      Color : Integer ;       // F    (0:CF@ 1`256)
      name  : string ;        // V{}`
      start_x : double ;      // zuʒuXW
      start_y : double ;      // zuʒuYW
      rotate_angle : double ; // ]p[]
      Scale : double ;        // {
   end;

   TSymbolZukeiDef = record   // \vfbV{}``
      exf   : Boolean ;       // ݃tO(True:L@False:)
      name  : string ;        // V{
      cnt   : Integer ;       // zu
      mOrd  : array of TDataOrder ;       // }
      mOrdN : Integer ;                   // 
      mTen  : array of TDataTenMarker;    // 􉽗vfb_}[J
      mTenN : Integer ;                   // 
      mLin  : array of TDataLine;         // 􉽗vfb
      mLinN : Integer ;                   // 
      mLns  : array of TDataLines;        // 􉽗vfbܐ
      mLnsN : Integer ;                   // 
      mCir  : array of TDataCircle;       // 􉽗vfb~
      mCirN : Integer ;                   // 
      mArc  : array of TDataArc;          // 􉽗vfb~
      mArcN : Integer ;                   // 
      mEll  : array of TDataEllipse;      // 􉽗vfbȉ~
      mEllN : Integer ;                   // 
      mEAr  : array of TDataEllipseArc;   // 􉽗vfbȉ~
      mEArN : Integer ;                   // 
      mTxt  : array of TDataText;         // 􉽗vfb
      mTxtN : Integer ;                   // 
      mBez  : array of TDataBezier;       // 􉽗vfbXvCxWFȐ
      mBezN : Integer ;                   // 
      mBsp  : array of TDataBspline;      // 􉽗vfbaXvCȐ
      mBspN : Integer ;                   // 
      mSpl  : array of TDataSpline;       // 􉽗vfbXvCȐ
      mSplN : Integer ;                   // 
      mClo  : array of TDataClothoid;     // 􉽗vfbN\ChȐ
      mCloN : Integer ;                   // 
   end;

   TDataFukugoZukei = record  // \vfb}`zu
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(0:`Ȃ 1`256)
      name  : string ;        // }`
      X     : double ;        // zuʒuXW
      Y     : double ;        // zuʒuYW
      Angle : double ;        // ]p[]
      ratio_x : double ;      // Xړx
      ratio_y : double ;      // Yړx
   end;

   TFukugoZukeiDef = record   // \vfb}``
      exf   : Boolean ;       // ݃tO(True:L@False:)
      name  : string ;        // }`
      Flag  : Integer ;       // ʃtO(1:}(wWn)A2: }(nWn)
                              //            3:}O[vA4:}i)
      cnt   : Integer ;       // zu
      mOrd  : array of TDataOrder ;       // }
      mOrdN : Integer ;                   // 
      mTen  : array of TDataTenMarker;    // 􉽗vfb_}[J
      mTenN : Integer ;                   // 
      mLin  : array of TDataLine;         // 􉽗vfb
      mLinN : Integer ;                   // 
      mLns  : array of TDataLines;        // 􉽗vfbܐ
      mLnsN : Integer ;                   // 
      mCir  : array of TDataCircle;       // 􉽗vfb~
      mCirN : Integer ;                   // 
      mArc  : array of TDataArc;          // 􉽗vfb~
      mArcN : Integer ;                   // 
      mEll  : array of TDataEllipse;      // 􉽗vfbȉ~
      mEllN : Integer ;                   // 
      mEAr  : array of TDataEllipseArc;   // 􉽗vfbȉ~
      mEArN : Integer ;                   // 
      mTxt  : array of TDataText;         // 􉽗vfb
      mTxtN : Integer ;                   // 
      mBez  : array of TDataBezier;       // 􉽗vfbXvCxWFȐ
      mBezN : Integer ;                   // 
      mBsp  : array of TDataBspline;      // 􉽗vfbaXvCȐ
      mBspN : Integer ;                   // 
      mSpl  : array of TDataSpline;       // 􉽗vfbXvCȐ
      mSplN : Integer ;                   // 
      mClo  : array of TDataClothoid;     // 􉽗vfbN\ChȐ
      mCloN : Integer ;                   // 
      mSzk  : array of TDataSymbolZukei;  // \vfbV{}`zu
      mSzkN : Integer ;                   // 
      mFzk  : array of TDataFukugoZukei;  // \vfb}`zu
      mFzkN : Integer ;                   // 
   end;

   TFukugoZukeiTree = record  // }`c[\
      name  : string ;        // }`
      level : integer ;       // Kwx(0:Root=p(̃f[^ɂ͊܂܂Ȃ) 1`)
      par   : integer ;       // eNo
      mtx   : TMatrix ;       // ϊs
   end;

   TDataClass = class
   public
      { Public 錾 }
      zt : TZumenTitle;    // }ʏb}ʕ\藓
      zp : TZumenPaper;    // }ʍ\bp
      zLay : array of TZumenLayer;        // }ʍ\bC
      zLayN: Integer ;                    // C
      zCol : array of TZumenColor;        // }ʍ\bF
      zColN: Integer ;                    // F
      zLtp : array of TZumenLtype;        // }ʍ\b
      zLtpN: Integer ;                    // 퐔
      zWid : array of TZumenWidth;        // }ʍ\b
      zWidN: Integer ;                    // 
      zFnt : array of TZumenFont;         // }ʍ\btHg
      zFntN: Integer ;                    // tHg
      dOrd  : array of TDataOrder ;       // }
      dOrdN : Integer ;                   // 
      dTen : array of TDataTenMarker;     // \Lvfb_}[J
      dTenN: Integer ;                    // 
      dLin : array of TDataLine;          // \Lvfb
      dLinN: Integer ;                    // 
      dLns : array of TDataLines;         // \Lvfbܐ
      dLnsN: Integer ;                    // 
      dCir : array of TDataCircle;        // \Lvfb~
      dCirN: Integer ;                    // 
      dArc : array of TDataArc;           // \Lvfb~
      dArcN: Integer ;                    // 
      dEll  : array of TDataEllipse;      // \Lvfbȉ~
      dEllN : Integer ;                   // 
      dEAr  : array of TDataEllipseArc;   // \Lvfbȉ~
      dEArN : Integer ;                   // 
      dTxt  : array of TDataText;         // \Lvfb
      dTxtN : Integer ;                   // 
      dBez  : array of TDataBezier;       // \LvfbXvCxWFȐ
      dBezN : Integer ;                   // 
      dBsp  : array of TDataBspline;      // \LvfbaXvCȐ
      dBspN : Integer ;                   // 
      dSpl  : array of TDataSpline;       // \LvfbXvCȐ
      dSplN : Integer ;                   // 
      dClo  : array of TDataClothoid;     // \LvfbN\ChȐ
      dCloN : Integer ;                   // 
      dSzk  : array of TDataSymbolZukei;  // \vfbV{}`zu
      dSzkN : Integer ;                   // 
      sDef : array of TSymbolZukeiDef;    // \vfbV{}``
      sDefN: Integer ;                    // 
      dFzk : array of TDataFukugoZukei;   // \vfb}`zu
      dFzkN: Integer ;                    // 
      fDef : array of TFukugoZukeiDef;    // \vfb}``
      fDefN: Integer ;                    // 
      zFzt : array of TFukugoZukeiTree;   // }`c[\
      zFztN: Integer ;                    // 
      constructor Create;
      destructor Free;
      procedure DataClear ;
      procedure DataClearZukei ;
      procedure DataClearSymbol ;
      procedure DataInit;
      procedure DataInitSymbol ;
      function  StrBytes(s:string) : integer;
      function  StrCheck(s:string) : Boolean;
      procedure PaperSet(t,o,x,y:integer);
      function  LayerNameCheck(n:integer;s:string) : Integer;
      function  AddLayer(s:string;fla,col,ltp,wid,fnt:integer) : Boolean;
      function  EditLayer(n:integer;s:string;fla,col,ltp,wid:integer) : Boolean;
      function  AddColor(r,g,b:integer) : Boolean;
      function  EditColor(n:integer;r,g,b:integer) : Boolean;
      function  LtypeNameCheck(n:integer;s:string) : Integer;
      function  AddLtype(s:string;seg:integer;pit:array of double) : Boolean;
      function  EditLtype(n:integer;s:string;seg:integer;pit:array of double) : Boolean;
      function  AddWidth(w:double) : Boolean;
      function  EditWidth(n:integer;w:double) : Boolean;
      function  FontNameCheck(n:integer;s:string) : Integer;
      function  AddFont(s:string) : Boolean;
      function  EditFont(n:integer;s:string) : Boolean;
      function  FZukeiNameCheck(n:integer;s:string) : Integer;
      function  AddFZukeiDef(s:string;f:integer) : Boolean;
      function  AddDataFZukei(s:string;lay:integer;nam:string;px,py,an,sx,sy:double) : Boolean;
      procedure MakeFZukeiTree ;
      function  AddSymbolDef(s:string) : Boolean;
      function  AddDataSZukei(s:string;lay,cf,col:integer;nam:string;px,py,an,sc:double) : Boolean;
      function  AddDataOrder(m,tp,no:integer) : Boolean;
      function  AddDataTen(s:string;lay,col,mc:integer;px,py,an,sc:double) : Boolean;
      function  AddDataLine(s:string;lay,col,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
      function  AddDataLines(s:string;lay,col,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
      function  AddDataCircle(s:string;lay,col,ltp,wid:integer;cx,cy,cr:double) : Boolean;
      function  AddDataArc(s:string;lay,col,ltp,wid,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
      function  AddDataEllipse(s:string;lay,col,ltp,wid:integer;cx,cy,rx,ry,ra:double) : Boolean;
      function  AddDataEllipseArc(s:string;lay,col,ltp,wid,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  AddDataText(s,st:string;lay,col,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
      function  AddDataBezier(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
      function  AddDataBspline(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
      function  AddDataSpline(s:string;lay,col,ltp,wid,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
      function  AddDataClothoid(s:string;lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double) : Boolean;
   private
      { Private 錾 }
      procedure MakeFZukeiTreeSub(no,lv,pa:integer) ;
      procedure AddLayerCnt(lay,col,ltp,wid,fnt:integer);
      procedure AddLayerFCnt(lay,col,ltp,wid,fnt:integer);
   end;

implementation

// 
constructor TDataClass.Create;
begin
   DataInit ;
   DataInitSymbol ;
end;

// 
destructor TDataClass.Free;
begin
   DataClear ;
end;

// 
procedure TDataClass.DataClear;
begin
   zLay  := nil;
   zLayN := 0;
   zCol  := nil;
   zColN := 0;
   zLtp  := nil;
   zLtpN := 0;
   zWid  := nil;
   zWidN := 0;
   zFnt  := nil;
   zFntN := 0;
   DataClearZukei ;
   DataClearSymbol ;
end;

//   }`f[^̂
procedure TDataClass.DataClearZukei ;
var
   i,j : integer ;
begin
   dOrd  := nil;
   dOrdN := 0;
   dTen  := nil;
   dTenN := 0;
   dLin  := nil;
   dLinN := 0;
   for i:=0 to dLnsN-1 do begin
      with dLns[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dLns  := nil;
   dLnsN := 0;
   dCir  := nil;
   dCirN := 0;
   dArc  := nil;
   dArcN := 0;
   dEll  := nil;
   dEllN := 0;
   dEAr  := nil;
   dEArN := 0;
   dTxt  := nil;
   dTxtN := 0;
   for i:=0 to dBezN-1 do begin
      with dBez[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dBez  := nil;
   dBezN := 0;
   for i:=0 to dBspN-1 do begin
      with dBsp[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dBsp  := nil;
   dBspN := 0;
   for i:=0 to dSplN-1 do begin
      with dSpl[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dSpl  := nil;
   dSplN := 0;
   dClo  := nil;
   dCloN := 0;
   dSzk  := nil;
   dSzkN := 0;
   dFzk  := nil;
   dFzkN := 0;
   for i:=0 to fDefN-1 do begin
      with fDef[i] do begin
         mOrd := nil;
         mTen := nil;
         mLin := nil;
         for j:=0 to mLnsN-1 do begin
            with mLns[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mLns := nil;
         mCir := nil;
         mArc := nil;
         mEll := nil;
         mEAr := nil;
         mTxt := nil;
         for j:=0 to mBezN-1 do begin
            with mBez[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mBez := nil;
         for j:=0 to mBspN-1 do begin
            with mBsp[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mBsp := nil;
         for j:=0 to mSplN-1 do begin
            with mSpl[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mSpl := nil;
         mClo := nil;
         mSzk := nil;
         mFzk := nil;
      end;
   end;
   fDef  := nil;
   fDefN := 0;
   zFzt  := nil;
   zFztN := 0;
end;

//   V{`f[^̂
procedure TDataClass.DataClearSymbol ;
var
   i,j : integer ;
begin
   for i:=0 to sDefN-1 do begin
      with sDef[i] do begin
         mOrd := nil;
         mTen := nil;
         mLin := nil;
         for j:=0 to mLnsN-1 do begin
            with mLns[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mLns := nil;
         mCir := nil;
         mArc := nil;
         mEll := nil;
         mEAr := nil;
         mTxt := nil;
         for j:=0 to mBezN-1 do begin
            with mBez[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mBez := nil;
         for j:=0 to mBspN-1 do begin
            with mBsp[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mBsp := nil;
         for j:=0 to mSplN-1 do begin
            with mSpl[j] do begin
               X := nil;
               Y := nil;
            end;
         end;
         mSpl := nil;
         mClo := nil;
      end;
   end;
   sDef  := nil;
   sDefN := 0;
end;

// lZbg
procedure TDataClass.DataInit;
var
   i : integer ;
begin
   // 񒷂0偁(NULL)͋Ȃ̂Ŕp󔒂܂
   with zt do begin
      P_Name   := ' ';
      C_Name   := ' ';
      C_type   := ' ';
      D_title  := ' ';
      D_number := ' ';
      D_type   := ' ';
      D_Scale  := '1/1';
      D_Year   := 2011;
      D_Month  := 1;
      D_Day    := 1;
      C_Contractor := ' ';
      C_Owner  := ' ';
   end;
   with zp do begin
      name  := ' ';
      typ   := 0;
      orient:= 1;
      x     := 1189;
      y     := 841;
   end;
   zLay  := nil;
   zLayN := 0;

   zCol  := nil;
   zColN := 16;
   SetLength(zCol,zColN);
   for i:=0 to zColN-1 do begin
      zCol[i].cnt := 0 ;
      zCol[i].Fcnt:= 0 ;
   end;
   EditColor( 1,   0,  0,  0);
   EditColor( 2, 255,  0,  0);
   EditColor( 3,   0,255,  0);
   EditColor( 4,   0,  0,255);
   EditColor( 5, 255,255,  0);
   EditColor( 6, 255,  0,255);
   EditColor( 7,   0,255,255);
   EditColor( 8, 255,255,255);
   EditColor( 9, 192,  0,128);
   EditColor(10, 192,128, 64);
   EditColor(11, 255,128,  0);
   EditColor(12, 128,192,128);
   EditColor(13,   0,128,255);
   EditColor(14, 128, 64,255);
   EditColor(15, 192,192,192);
   EditColor(16, 128,128,128);

   zLtp  := nil;
   zLtpN := 16;
   SetLength(zLtp,zLtpN);
   for i:=0 to zLtpN-1 do begin
      zLtp[i].cnt := 0 ;
      zLtp[i].Fcnt:= 0 ;
   end;
   EditLtype(1,'continuous'                        ,0,[ 0.0,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(2,'dashed'                            ,2,[ 6.0,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(3,'dashed spaced'                     ,2,[ 6.0,6.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(4,'long dashed dotted'                ,4,[12.0,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(5,'long dashed double-dotted'         ,6,[12.0,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(6,'long dashed triplicate-dotted'     ,8,[12.0,1.5,0.25,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0]);
   EditLtype(7,'dotted'                            ,2,[0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(8,'chain'                             ,4,[12.0,1.5,3.5 ,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(9,'chain double dash'                 ,6,[12.0,1.5,3.5 ,1.5,3.5 ,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(10,'dashed dotted'                    ,4,[6.0 ,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(11,'Double-dashed dotted'             ,6,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(12,'dashed double-dotted'             ,6,[6.0 ,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0]);
   EditLtype(13,'double-dashed double-dotted'      ,8,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0]);
   EditLtype(14,'dashed triplicate-dotted'         ,8,[6.0 ,1.5,0.25,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0]);
   EditLtype(15,'double-dashed triplicate-dotted' ,10,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.25,1.5,0.25,1.5]);
   EditLtype(16,'gp'                           ,0,[0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0]);

   zWid  := nil;
   zWidN := 10;
   SetLength(zWid,zWidN);
   for i:=0 to zWidN-1 do begin
      zWid[i].cnt := 0 ;
      zWid[i].Fcnt:= 0 ;
   end;
   EditWidth( 1, 0.13);
   EditWidth( 2, 0.18);
   EditWidth( 3, 0.25);
   EditWidth( 4, 0.35);
   EditWidth( 5, 0.5 );
   EditWidth( 6, 0.7 );
   EditWidth( 7, 1.0 );
   EditWidth( 8, 1.4 );
   EditWidth( 9, 2.0 );
   EditWidth(10, 0.01); // gp

   zFnt  := nil;
   zFntN := 0;

   dOrd  := nil;
   dOrdN := 0;
   dTen  := nil;
   dTenN := 0;
   dLin  := nil;
   dLinN := 0;
   dLns  := nil;
   dLnsN := 0;
   dCir  := nil;
   dCirN := 0;
   dArc  := nil;
   dArcN := 0;
   dEll  := nil;
   dEllN := 0;
   dEAr  := nil;
   dEArN := 0;
   dTxt  := nil;
   dTxtN := 0;
   dBez  := nil;
   dBezN := 0;
   dBsp  := nil;
   dBspN := 0;
   dSpl  := nil;
   dSplN := 0;
   dClo  := nil;
   dCloN := 0;
   dSzk  := nil;
   dSzkN := 0;
   dFzk  := nil;
   dFzkN := 0;

   fDef  := nil;
   fDefN := 0;
   zFzt  := nil;
   zFztN := 0;
end;

// V{`f[^@lZbg
procedure TDataClass.DataInitSymbol ;
begin
   sDef  := nil;
   sDefN := 0;
end;

// 񒷂擾
//    (ret) 񒷂ioCgj
function TDataClass.StrBytes(s:string) : integer;
var
   t : AnsiString ;
begin
   t := AnsiString(s) ;
   Result := Length(t) ;
end;

// `FbN
//    (ret) OK : True  NG : False
//     0񒷁256 ǂ`FbN
function TDataClass.StrCheck(s:string) : Boolean;
var
   t : AnsiString ;
   l : integer ;
begin
   t := AnsiString(s) ;
   l := Length(t) ;
   if (l > 0) and (l <= 256) then
      Result := True
   else
      Result := False ;
end;

// pTCYZbg
//    t : (0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
//          {(10:A0~2 11:A0~3 12:A1~3 13:A1~4 14:A2~3 15:A2~4 16:A2~5
//             17:A3~3 18:A3~4 19:A3~5 20:A3~6 21:A3~7 22:A4~3 23:A4~4
//             24:A4~5 25:A4~6 26:A4~7 27:A4~8 28:A4~9)
//          {(30:B0 31:B1 32:B2 33:B3 34:B4 35:B5 36:B6)
//    o : c^敪(0:c,1:)
//    x : Rp(Pmm) t=9̎Ɏw
//    y : Rpc(Pmm) t=9̎Ɏw
procedure TDataClass.PaperSet(t,o,x,y:integer);
begin
   case(t)of
   0: begin
         x := 1189;
         y :=  841;
      end;
   1: begin
         x := 841;
         y := 594;
      end;
   2: begin
         x := 594;
         y := 420;
      end;
   3: begin
         x := 420;
         y := 297;
      end;
   4: begin
         x := 297;
         y := 210;
      end;
   10:begin // A0~2
         x := 1682;
         y := 1189;
      end;
   11:begin // A0~3
         x := 2523;
         y := 1189;
      end;
   12:begin // A1~3
         x := 1783;
         y :=  841;
      end;
   13:begin // A1~4
         x := 2378;
         y :=  841;
      end;
   14:begin // A2~3
         x := 1261;
         y :=  594;
      end;
   15:begin // A2~4
         x := 1682;
         y :=  594;
      end;
   16:begin // A2~5
         x := 2102;
         y :=  594;
      end;
   17:begin // A3~3
         x :=  891;
         y :=  420;
      end;
   18:begin // A3~4
         x := 1189;
         y :=  420;
      end;
   19:begin // A3~5
         x := 1486;
         y :=  420;
      end;
   20:begin // A3~6
         x := 1783;
         y :=  420;
      end;
   21:begin // A3~7
         x := 2080;
         y :=  420;
      end;
   22:begin // A4~3
         x :=  630;
         y :=  297;
      end;
   23:begin // A4~4
         x :=  841;
         y :=  297;
      end;
   24:begin // A4~5
         x := 1051;
         y :=  297;
      end;
   25:begin // A4~6
         x := 1261;
         y :=  297;
      end;
   26:begin // A4~7
         x := 1471;
         y :=  297;
      end;
   27:begin // A4~8
         x := 1682;
         y :=  297;
      end;
   28:begin // A4~9
         x := 1892;
         y :=  297;
      end;
   30:begin // B0
			x := 1456;
			y := 1028;
      end;
   31:begin // B1
			x := 1028;
			y :=  728;
      end;
   32:begin // B2
			x := 728;
			y := 514;
      end;
   33:begin // B3
			x := 514;
			y := 364;
      end;
   34:begin // B4
         x := 364;
			y := 257;
      end;
   35:begin // B5
         x := 257;
			y := 182;
      end;
   36:begin // B6
			x := 182;
			y := 128;
      end;
   end;
   if (t >= 0)and(t <= 4) then begin
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;  // CM[lłꍇɔ
   end
   else if (t >= 10)and(t <= 28)
         or(t >= 30)and(t <= 36) then begin
      t := 9 ;
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;
   end
   else begin
      t := 9 ;
      if (x < 100) then x := 100 ;   // RTCY̏ꍇ̒l`FbN
      if (y < 100) then y := 100 ;   //    100mm`10000mmƂĂ
      if (x > 10000) then x := 10000 ;
      if (y > 10000) then y := 10000 ;
      // p̌
      if (x >= y) then
         o := 1
      else
         o := 0 ;
   end;

   zp.typ      := t ;
   zp.orient   := o ;
   zp.x        := x ;
   zp.y        := y ;
end;

// w肵C̃Cԍ擾
//    n  : `FbNO郌Cԍ(0,1-256)
//    s  : C
// (ret) 1`256FCԍ@0:o^
//    xPlA擪32oCgŃ`FbN
//    C̏d`FbNɂp
function TDataClass.LayerNameCheck(n:integer;s:string) : Integer;
var
   i,j : integer;
   s1,s2 : AnsiString ;
begin
   Result := 0 ;
   s1 := AnsiString(s) ;
   s1 := MidStr2(s1,1,32,j);
   for i:=0 to zLayN-1 do begin
      if (i = (n-1)) then continue;    // w背Cԍ̓`FbNX[
      s2 := AnsiString(zLay[i].name) ;
      s2 := MidStr2(s2,1,32,j);
      if (s1 = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// C@f[^ڂ̒ǉo^
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
//    fnt: CtHg(1-1024)
// (ret) True:o^OK@False:NG
function TDataClass.AddLayer(s:string;fla,col,ltp,wid,fnt:integer) : Boolean;
begin
   Result := False;
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LayerNameCheck(0,s) > 0) then exit;   // ɃC͎gp
   if (zLayN = LAYER_MAX_NUM) then exit ;    // ȏヌC͓o^s

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColN) then col := 1;
   if (ltp < 1)or(ltp > zLtpN)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidN) then wid := 1;
   if (fnt < 1)or(fnt > zFntN) then fnt := 1;

   Inc(zLayN);
   SetLength(zLay, zLayN);
   with zLay[zLayN-1] do begin
      name  := s ;
      Lflag := fla ;
      Color := col ;
      Ltype := ltp ;
      Width := wid ;
      Mfont := fnt ;
      cnt   := 0 ;
      Fcnt  := 0 ;
   end;
   Result := True ;
end;

// C@f[^ڂ̕ҏWo^
//    n  : Cԍ(1-256)
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
// (ret) True:o^OK@False:NG
function TDataClass.EditLayer(n:integer;s:string;fla,col,ltp,wid:integer) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zLayN) then exit;        // CԍG[
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LayerNameCheck(n,s) > 0) then exit;   // ɃC͎gp

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColN) then col := 1;
   if (ltp < 1)or(ltp > zLtpN)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidN) then wid := 1;

   with zLay[n-1] do begin
      name  := s ;
      Lflag := fla ;
      Color := col ;
      Ltype := ltp ;
      Width := wid ;
   end;
   Result := True ;
end;

// F@f[^ڂ̒ǉo^
//    r : ql(0-255)
//    g : fl(0-255)
//    b : al(0-255)
// (ret) True:o^OK@False:NG
function TDataClass.AddColor(r,g,b:integer) : Boolean;
begin
   Result := False;
   if (zColN = COLOR_MAX_NUM) then exit ;    // ȏF͓o^s

   if (r < 0) then r := 0;
   if (g < 0) then g := 0;
   if (b < 0) then b := 0;
   if (r > 255) then r := 255;
   if (g > 255) then g := 255;
   if (b > 255) then b := 255;

   Inc(zColN);
   SetLength(zCol, zColN);
   with zCol[zColN-1] do begin
      Red   := r ;
      Green := g ;
      Blue  := b ;
      cnt   := 0 ;
      Fcnt  := 0 ;
   end;
   Result := True ;
end;

// F@f[^ڂ̕ҏWo^
//    n : Fԍ(1-256)
//    r : ql(0-255)
//    g : fl(0-255)
//    b : al(0-255)
// (ret) True:o^OK@False:NG
//    Fԍ 1-16̕ҏWo^\łASXFdlł͗pґɂҏW͕s
function TDataClass.EditColor(n:integer;r,g,b:integer) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zColN) then exit;        // FԍG[

   if (r < 0) then r := 0;
   if (g < 0) then g := 0;
   if (b < 0) then b := 0;
   if (r > 255) then r := 255;
   if (g > 255) then g := 255;
   if (b > 255) then b := 255;

   with zCol[n-1] do begin
      Red   := r ;
      Green := g ;
      Blue  := b ;
   end;
   Result := True ;
end;

// w肵햼̐ԍ擾
//    n  : `FbNOԍ(0,1-32)
//    s  : 햼
// (ret) 1`32Fԍ@0:o^
//   햼̏d`FbNɂp
function TDataClass.LtypeNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zLtpN-1 do begin
      if (i = (n-1)) then continue;    // wԍ̓`FbNX[
      s2 := zLtp[i].name ;
      if (s = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : 햼
//    seg: ZOg(0-10)
//    pit: esb` (10vf)
// (ret) True:o^OK@False:NG
function TDataClass.AddLtype(s:string;seg:integer;pit:array of double) : Boolean;
var
   i : integer;
begin
   Result := False;
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LtypeNameCheck(0,s) > 0) then exit;   // ɐ햼͎gp
   if (zLtpN = LTYPE_MAX_NUM) then exit ;    // ȏ͓o^s

   if (seg < 0)or(seg > 10) then seg := 0;
   for i:=0 to 9 do begin
      if (pit[i] <    0.0) then pit[i] :=    0.0;
      if (pit[i] > 1000.0) then pit[i] := 1000.0;
   end;

   Inc(zLtpN);
   SetLength(zLtp, zLtpN);
   with zLtp[zLtpN-1] do begin
      name     := s ;
      Segment  := seg ;
      for i:=0 to 9 do
         Pitch[i] := 0.0 ;
      for i:=0 to seg-1 do
         Pitch[i] := pit[i] ;
      SpaceMax := 0.0 ;
      for i:=0 to (seg div 2 - 1) do begin
         if (SpaceMax < Pitch[i*2+1]) then
            SpaceMax := Pitch[i*2+1] ;
      end;
      cnt   := 0 ;
      Fcnt  := 0 ;
   end;
   Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    n  : ԍ(1-32)
//    s  : 햼
//    seg: ZOg(0-10)
//    pit: esb` (10vf)
// (ret) True:o^OK@False:NG
function TDataClass.EditLtype(n:integer;s:string;seg:integer;pit:array of double) : Boolean;
var
   i : integer;
begin
   Result := False;
   if (n < 1)or(n > zLtpN) then exit;        // ԍG[
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LtypeNameCheck(n,s) > 0) then exit;   // ɐ햼͎gp

   if (seg < 0)or(seg > 10) then seg := 0;
   for i:=0 to 9 do begin
      if (pit[i] <    0.0) then pit[i] :=    0.0;
      if (pit[i] > 1000.0) then pit[i] := 1000.0;
   end;

   with zLtp[n-1] do begin
      name     := s ;
      Segment  := seg ;
      for i:=0 to 9 do
         Pitch[i] := 0.0 ;
      for i:=0 to seg-1 do
         Pitch[i] := pit[i] ;
      SpaceMax := 0.0 ;
      for i:=0 to (seg div 2 - 1) do begin
         if (SpaceMax < Pitch[i*2+1]) then
            SpaceMax := Pitch[i*2+1] ;
      end;
   end;
   Result := True ;
end;

// @f[^ڂ̒ǉo^
//    w : (0.01-1000)
// (ret) True:o^OK@False:NG
function TDataClass.AddWidth(w:double) : Boolean;
begin
   Result := False;
   if (zWidN = WIDTH_MAX_NUM) then exit ;    // ȏ͓o^s

   if (w <   0.01) then w :=   0.01;
   if (w > 1000.0) then w := 1000.0;   // SXFdlł 010^15Ƃ܂

   Inc(zWidN);
   SetLength(zWid, zWidN);
   with zWid[zWidN-1] do begin
      Width := w ;
      cnt   := 0 ;
      Fcnt  := 0 ;
   end;
   Result := True ;
end;

// @f[^ڂ̒ǉo^
//    n : ԍ(1-16)
//    w : (0.01-1000)
// (ret) True:o^OK@False:NG
function TDataClass.EditWidth(n:integer;w:double) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zWidN) then exit;        // ԍG[

   if (w <   0.01) then w :=   0.01;
   if (w > 1000.0) then w := 1000.0;   // SXFdlł 010^15Ƃ܂

   with zWid[n-1] do begin
      Width := w ;
   end;
   Result := True ;
end;

// w肵tHg̕tHgԍ擾
//    n  : `FbNO镶tHgԍ(0,1-1024)
//    s  : tHg
// (ret) 1`1024Fԍ@0:o^
function TDataClass.FontNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zFntN-1 do begin
      if (i = (n-1)) then continue;    // w蕶tHgԍ̓`FbNX[
      s2 := zFnt[i].name ;
      if (s = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// tHg@f[^ڂ̒ǉo^
//    s  : tHg
// (ret) True:o^OK@False:NG
function TDataClass.AddFont(s:string) : Boolean;
begin
   Result := False;
   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   // if (FontNameCheck(0,s) > 0) then exit;    // ***ɕtHg͎gp***d`FbN͂Ȃ
   if (zFntN = MFONT_MAX_NUM) then exit ;       // ȏ㕶tHg͓o^s

   Inc(zFntN);
   SetLength(zFnt, zFntN);
   with zFnt[zFntN-1] do begin
      name  := s ;
      cnt   := 0 ;
      Fcnt  := 0 ;
   end;
   Result := True ;
end;

// tHg@f[^ڂ̕ҏWo^
//    n  : tHgԍ(1-1024)
//    s  : tHg
// (ret) True:o^OK@False:NG
function TDataClass.EditFont(n:integer;s:string) : Boolean;
begin
   Result := False;
   if (n < 1)or(n > zFntN) then exit;           // tHgԍG[
   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   // if (FontNameCheck(n,s) > 0) then exit;    // ***ɕtHg͎gp***d`FbN͂Ȃ

   with zFnt[n-1] do begin
      name  := s ;
   end;
   Result := True ;
end;

// w肵}`̔ԍ擾
//    n  : `FbNOԍ(0,1`,`-1)
//    s  : }`
// (ret) 1`F}`̔ԍ@0:o^@`-1:V{̔ԍ
function TDataClass.FZukeiNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to fDefN-1 do begin
      if not(fDef[i].exf) then continue;        // ݂Ȃꍇ̓X[
      if (n > 0)and(i = (n-1)) then continue;   // wԍ̓`FbNX[
      s2 := fDef[i].name ;
      if (s = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
   // V{̃`FbN
   if (Result = 0) then begin
      for i:=0 to sDefN-1 do begin
         if not(sDef[i].exf) then continue;           // ݂Ȃꍇ̓X[
         if (n < 0)and(i = (Abs(n)-1)) then continue; // wԍ̓`FbNX[
         s2 := sDef[i].name ;
         if (s = s2) then begin
            Result := -(i + 1);
            break ;
         end;
      end;
   end;
end;

// }``@f[^ڂ̒ǉo^
//    ł́AOƃtÔݓo^@̊ef[^͕ʓro^
//    s  : }`
//    f  : tO(1-4)
// (ret) True:o^OK@False:NG
function TDataClass.AddFZukeiDef(s:string;f:integer) : Boolean;
var
   l : integer ;
begin
   Result := False;
   if (f < 1)or(f > 4) then exit;   // tOwG[
   l := StrBytes(s);
   if (f <= 2) then begin
      if (l < 1)or(l > (256-9)) then exit;   // }(XY)P21t@Cu$$SXF_FM_v擪ɕt
                                             // }(YX)P21t@Cu$$SXF_FG_v擪ɕt
   end
   else begin
      if (l < 1)or(l > (256-8)) then exit;   // }O[vP21t@Cu$$SXF_G_v擪ɕt
                                             // }í@@P21t@Cu$$SXF_P_v擪ɕt
   end;
   if (FZukeiNameCheck(0,s) <> 0) then exit; // ɕ}`͎gp

   try
      Inc(fDefN);
      SetLength(fDef, fDefN);
      with fDef[fDefN-1] do begin
         exf   := True ;
         name  := s ;
         Flag  := f ;
         cnt   := 0 ;
      end;
      Result := True ;
   except
      Dec(fDefN);
      SetLength(fDef, fDefN);
   end;
end;

// }`zu@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    lay: C(0,1-256)
//    nam: }`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sx : ړxX
//    sy : ړxY
// (ret) True:o^OK@False:NG
function TDataClass.AddDataFZukei(s:string;lay:integer;nam:string;px,py,an,sx,sy:double) : Boolean;
var
   m,n,f1,f2 : integer ;
begin
   Result := False;
   n := FZukeiNameCheck(0,nam);
   if (n <= 0) then exit ;    // zu镡}`͖̂ŃG[
   if (fDef[n-1].Flag = 3) then begin
      // zu悤ƂĂ镡}`}O[v̏ꍇ
      if (fDef[n-1].cnt <> 0) then exit ;   // ɔzuς݂Ȃ̂ŃG[
      px := 0.0 ;
      py := 0.0 ;
      an := 0.0 ;
      sx := 1.0 ;
      sy := 1.0 ;
   end;

   if (lay < 0) or (lay > zLayN) then lay := 0 ;
   an := SetAngle(an);
   if (sx < LIMIT8) then sx := 1.0;
   if (sy < LIMIT8) then sy := 1.0;

   if (s = '') then begin
      // p֒ǉ
      try
         Inc(dFzkN);
         SetLength(dFzk, dFzkN);
         with dFzk[dFzkN-1] do begin
            exf   := True ;
            Layer := lay ;
            name  := nam ;
            X     := px ;
            Y     := py ;
            Angle := an ;
            ratio_x  := sx ;
            ratio_y  := sy ;
         end;
         Result := True ;
      except
         Dec(dFzkN);
         SetLength(dFzk, dFzkN);
      end;
      if (Result) then
         fDef[n-1].cnt := fDef[n-1].cnt + 1 ; // zuJEg
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m <= 0) then exit ;    // ǉ̕}`͖̂ŃG[
      if (m =  n) then exit ;    // ǉƔzu̕}`Ȃ̂ŃG[
      f1 := fDef[m-1].Flag ;
      f2 := fDef[n-1].Flag ;
      if (f1 = 1)or(f1 = 2) then begin
         // ǉ悪}̏ꍇ
         if (f2 = 1)or(f2 = 2) then exit ;   // }̒ɕ}͕̂s
      end
      else if (f1 = 3) then begin
         // ǉ悪}O[v̏ꍇ
         if (f2 = 1)or(f2 = 2) then exit ;   // }O[v̒ɕ}͕̂s
      end
      else begin
         // ǉ悪}ȉꍇ
         if (f2 = 1)or(f2 = 2)or(f2 = 3) then exit ;  // }i̒ɕ}E}O[v͕̂s
      end;
      // [vɂȂ悤ȔzuȂ悤ӂĉ
      with fDef[m-1] do begin
         try
            Inc(mFzkN);
            SetLength(mFzk, mFzkN);
            with mFzk[mFzkN-1] do begin
               exf   := True ;
               Layer := lay ;
               name  := nam ;
               X     := px ;
               Y     := py ;
               Angle := an ;
               ratio_x  := sx ;
               ratio_y  := sy ;
            end;
            Result := True ;
         except
            Dec(mFzkN);
            SetLength(mFzk, mFzkN);
         end;
      end;
      if (Result) then
         fDef[n-1].cnt := fDef[n-1].cnt + 1 ; // zuJEg
   end;
end;

// }`c[\@
//    }`̕}`擾ċApTu
//    no : e̕}`` ԍ(1`)
//    lv : Kwx(0:root(p) 1`)   [v̂ߍő100Kw܂łƂ
//    pa : ẽc[ԍ(0`)
procedure TDataClass.MakeFZukeiTreeSub(no,lv,pa:integer) ;
var
   i,j : integer ;
   t,t1 : TMatrix ;
begin
   if (lv > 100) then exit ;
   for i:=0 to fDef[no-1].mFzkN-1 do begin
      if not(fDef[no-1].mFzk[i].exf) then continue ;
      j := FZukeiNameCheck(0,fDef[no-1].mFzk[i].name) ;
      if (j <= 0) then continue;
      Inc(zFztN);
      if ((zFztN mod 200) = 1) then SetLength(zFzt,zFztN+199); // 200m
      with zFzt[zFztN-1] do begin
         name  := fDef[no-1].mFzk[i].name;
         level := lv;
         par   := pa;
         //
         MtxScale(t, fDef[no-1].mFzk[i].ratio_x,fDef[no-1].mFzk[i].ratio_y);
         MtxRotD(t1, fDef[no-1].mFzk[i].Angle);
         t := MtxMult(t, t1);
         MtxMove(t1, fDef[no-1].mFzk[i].X,fDef[no-1].mFzk[i].Y);
         t := MtxMult(t, t1);
         t1:= zFzt[pa].mtx ;  // e̕ϊs
         mtx   := MtxMult(t, t1);
      end;
      MakeFZukeiTreeSub(j,lv+1,zFztN-1);
   end;
end;

// }`c[\@
//    zFztNAzFzt
procedure TDataClass.MakeFZukeiTree ;
var
   i,j : integer ;
   t : TMatrix ;
begin
   zFzt  := nil;
   zFztN := 0;
   for i:=0 to dFzkN-1 do begin
      if not(dFzk[i].exf) then continue ;
      j := FZukeiNameCheck(0,dFzk[i].name) ;
      if (j <= 0) then continue;
      Inc(zFztN);
      if ((zFztN mod 200) = 1) then SetLength(zFzt,zFztN+199); // 200m
      with zFzt[zFztN-1] do begin
         name  := dFzk[i].name;
         level := 1 ;
         par   :=-1;
         //
         if (fDef[j-1].Flag = 2) then
            MtxSetYX(mtx)     // }YXWn
         else
            MtxSetE(mtx);
         MtxScale(t, dFzk[i].ratio_x,dFzk[i].ratio_y);
         mtx := MtxMult(mtx, t);
         MtxRotD(t, dFzk[i].Angle);
         mtx := MtxMult(mtx, t);
         MtxMove(t, dFzk[i].X,dFzk[i].Y);
         mtx := MtxMult(mtx, t);
      end;
      MakeFZukeiTreeSub(j,2,zFztN-1);
   end;
   SetLength(zFzt,zFztN);  // ]Ƀmۂ
end;

// V{}``@f[^ڂ̒ǉo^
//    ł́AÔݓo^@̊ef[^͕ʓro^
//    s  : V{
// (ret) True:o^OK@False:NG
function TDataClass.AddSymbolDef(s:string) : Boolean;
var
   l : integer ;
begin
   Result := False;
   l := StrBytes(s);
   if (l < 1)or(l > 256) then exit;
   if (FZukeiNameCheck(0,s) <> 0) then exit;  // Ɏgp

   try
      Inc(sDefN);
      SetLength(sDef, sDefN);
      with sDef[sDefN-1] do begin
         exf   := True ;
         name  := s ;
         cnt   := 0 ;
      end;
      Result := True ;
   except
      Dec(sDefN);
      SetLength(sDef, sDefN);
   end;
end;

// V{}`zu@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    lay: C(0,1-256)
//    cf : FR[htO(0: 1:L)
//    col: F (0:CF 1`256)
//    nam: V{}`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : {
// (ret) True:o^OK@False:NG
//  f[^ԍ́AЂƂ\L^􉽗vfǉ邩Ȃ̂ŗ]T 100 ƂĂ܂
function TDataClass.AddDataSZukei(s:string;lay,cf,col:integer;nam:string;px,py,an,sc:double) : Boolean;
var
   m,n : integer ;
begin
   Result := False;
   if (lay < 0) or (lay > zLayN) then lay := 0 ;
   if (cf <> 1) then cf := 0 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (nam = '') then exit ;
   n  := FZukeiNameCheck(0,nam);  // V{}`Ăo^͍s
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,100,dSzkN)) then begin
         try
            Inc(dSzkN);
            if ((dSzkN mod 200) = 1) then SetLength(dSzk, dSzkN+199);   // 200m
            with dSzk[dSzkN-1] do begin
               exf         := True ;
               Layer       := lay ;
               color_flag  := cf ;
               Color       := col ;
               name        := nam ;
               start_x     := px ;
               start_y     := py ;
               rotate_angle:= an ;
               Scale       := sc ;
            end;
            Result := True ;
            if (cf = 0) then
               AddLayerCnt(lay,-1,-1,-1,-1)
            else
               AddLayerCnt(lay,col,-1,-1,-1);
         except
            Dec(dSzkN);
            Dec(dOrdN);
         end;
         if (Result)and(n < 0) then
            sDef[-n-1].cnt := sDef[-n-1].cnt + 1 ; // zuJEg
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,100,mSzkN)) then begin
               try
                  Inc(mSzkN);
                  if ((mSzkN mod 200) = 1) then SetLength(mSzk, mSzkN+199);   // 200m
                  with mSzk[mSzkN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     color_flag  := cf ;
                     Color       := col ;
                     name        := nam ;
                     start_x     := px ;
                     start_y     := py ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  Result := True ;
                  if (cf = 0) then
                     AddLayerFCnt(lay,-1,-1,-1,-1)
                  else
                     AddLayerFCnt(lay,col,-1,-1,-1);
               except
                  Dec(mSzkN);
                  Dec(mOrdN);
               end;
            end;
         end;
         if (Result)and(n < 0) then
            sDef[-n-1].cnt := sDef[-n-1].cnt + 1 ; // zuJEg
      end
   end;
end;

// C̐{P
//    C̃R[h̓`FbNĂȂ̂ŒӁFOɃ`FbNςł鎖
//    lay: C(1-256)            -1:{PȂ(̏ꍇCF///̑ΉsȂ̂ŗv)
//    col: F(0,1-256)              -1:{PȂ
//    ltp: (0,1-32)             -1:{PȂ
//    wid: (0,1-16)             -1:{PȂ
//    fnt: tHg(0,1-1024)   -1:{PȂ
procedure TDataClass.AddLayerCnt(lay,col,ltp,wid,fnt:integer);
var
   i : integer ;
begin
   // C 
   if (lay > 0) then
      zLay[lay-1].cnt := zLay[lay-1].cnt + 1;
   // F 
   if (col > 0) then
      zCol[col-1].cnt := zCol[col-1].cnt + 1
   else if (col = 0)and(lay > 0) then begin
      i := zLay[lay-1].Color;
      zCol[i-1].cnt := zCol[i-1].cnt + 1;
   end;
   //  
   if (ltp > 0) then
      zLtp[ltp-1].cnt := zLtp[ltp-1].cnt + 1
   else if (ltp = 0)and(lay > 0) then begin
      i := zLay[lay-1].Ltype ;
      zLtp[i-1].cnt := zLtp[i-1].cnt + 1;
   end;
   //  
   if (wid > 0) then
      zWid[wid-1].cnt := zWid[wid-1].cnt + 1
   else if (wid = 0)and(lay > 0) then begin
      i := zLay[lay-1].Width ;
      zWid[i-1].cnt := zWid[i-1].cnt + 1;
   end;
   // tHg 
   if (fnt > 0) then
      zFnt[fnt-1].cnt := zFnt[fnt-1].cnt + 1
   else if (fnt = 0)and(lay > 0) then begin
      i := zLay[lay-1].Mfont ;
      zFnt[i-1].cnt := zFnt[i-1].cnt + 1;
   end;
end;

// }``@C̐{P
//    C̃R[h̓`FbNĂȂ̂ŒӁFOɃ`FbNςł鎖
//    lay: C(1-256)            -1:{PȂ(̏ꍇCF///̑ΉsȂ̂ŗv)
//    col: F(0,1-256)              -1:{PȂ
//    ltp: (0,1-32)             -1:{PȂ
//    wid: (0,1-16)             -1:{PȂ
//    fnt: tHg(0,1-1024)   -1:{PȂ
procedure TDataClass.AddLayerFCnt(lay,col,ltp,wid,fnt:integer);
var
   i : integer ;
begin
   // C 
   if (lay > 0) then
      zLay[lay-1].Fcnt := zLay[lay-1].Fcnt + 1;
   // F 
   if (col > 0) then
      zCol[col-1].Fcnt := zCol[col-1].Fcnt + 1
   else if (col = 0)and(lay > 0) then begin
      i := zLay[lay-1].Color;
      zCol[i-1].Fcnt := zCol[i-1].Fcnt + 1;
   end;
   //  
   if (ltp > 0) then
      zLtp[ltp-1].Fcnt := zLtp[ltp-1].Fcnt + 1
   else if (ltp = 0)and(lay > 0) then begin
      i := zLay[lay-1].Ltype ;
      zLtp[i-1].Fcnt := zLtp[i-1].Fcnt + 1;
   end;
   //  
   if (wid > 0) then
      zWid[wid-1].Fcnt := zWid[wid-1].Fcnt + 1
   else if (wid = 0)and(lay > 0) then begin
      i := zLay[lay-1].Width ;
      zWid[i-1].Fcnt := zWid[i-1].Fcnt + 1;
   end;
   // tHg 
   if (fnt > 0) then
      zFnt[fnt-1].Fcnt := zFnt[fnt-1].Fcnt + 1
   else if (fnt = 0)and(lay > 0) then begin
      i := zLay[lay-1].Mfont ;
      zFnt[i-1].Fcnt := zFnt[i-1].Fcnt + 1;
   end;
end;

// f[^}̓o^
//    m : }``No  0:p  `-1:V{`
//    tp: f[^^Cv (1-)
//    no: f[^ԍ   (0-)
function TDataClass.AddDataOrder(m,tp,no:integer) : Boolean;
begin
   Result := False;
   if (m = 0) then begin
      try
         Inc(dOrdN);
         if ((dOrdN mod 200) = 1) then SetLength(dOrd, dOrdN+199);   // 200m
         with dOrd[dOrdN-1] do begin
            DataType := tp ;
            DataNo   := no ;
         end;
         Result := True ;
      except
         Dec(dOrdN);
      end;
   end
   else if (m > 0) then begin
      with fDef[m-1] do begin
         try
            Inc(mOrdN);
            if ((mOrdN mod 200) = 1) then SetLength(mOrd, mOrdN+199);   // 200m
            with mOrd[mOrdN-1] do begin
               DataType := tp ;
               DataNo   := no ;
            end;
            Result := True ;
         except
            Dec(mOrdN);
         end;
      end;
   end
   else begin
      with sDef[-m-1] do begin
         try
            Inc(mOrdN);
            if ((mOrdN mod 200) = 1) then SetLength(mOrd, mOrdN+199);   // 200m
            with mOrd[mOrdN-1] do begin
               DataType := tp ;
               DataNo   := no ;
            end;
            Result := True ;
         except
            Dec(mOrdN);
         end;
      end;
   end;
end;

// _}[J@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F(0,1-256)
//    mc : }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:o^OK@False:NG
function TDataClass.AddDataTen(s:string;lay,col,mc:integer;px,py,an,sc:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (mc  < 1) or (mc  > 7)     then mc  := 3 ;   // dot
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,1,dTenN)) then begin
         try
            Inc(dTenN);
            if ((dTenN mod 200) = 1) then SetLength(dTen, dTenN+199);   // 200m
            with dTen[dTenN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               start_x     := px ;
               start_y     := py ;
               marker_code := mc ;
               rotate_angle:= an ;
               Scale       := sc ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,-1,-1,-1);
         except
            Dec(dTenN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,1,mTenN)) then begin
               try
                  Inc(mTenN);
                  if ((mTenN mod 200) = 1) then SetLength(mTen, mTenN+199);   // 200m
                  with mTen[mTenN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     start_x     := px ;
                     start_y     := py ;
                     marker_code := mc ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,-1,-1,-1);
               except
                  Dec(mTenN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,1,mTenN)) then begin
               try
                  Inc(mTenN);
                  if ((mTenN mod 200) = 1) then SetLength(mTen, mTenN+199);   // 200m
                  with mTen[mTenN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     start_x     := px ;
                     start_y     := py ;
                     marker_code := mc ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  Result := True ;
               except
                  Dec(mTenN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    x1 : n_X
//    y1 : n_Y
//    x2 : I_X
//    y2 : I_Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataLine(s:string;lay,col,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (Abs(x2-x1) < LIMIT10)and(Abs(y2-y1) < LIMIT10) then exit ; // _

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,2,dLinN)) then begin
         try
            Inc(dLinN);
            if ((dLinN mod 200) = 1) then SetLength(dLin, dLinN+199);   // 200m
            with dLin[dLinN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               start_x     := x1 ;
               start_y     := y1 ;
               end_x       := x2 ;
               end_y       := y2 ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dLinN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,2,mLinN)) then begin
               try
                  Inc(mLinN);
                  if ((mLinN mod 200) = 1) then SetLength(mLin, mLinN+199);   // 200m
                  with mLin[mLinN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     start_x     := x1 ;
                     start_y     := y1 ;
                     end_x       := x2 ;
                     end_y       := y2 ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mLinN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,2,mLinN)) then begin
               try
                  Inc(mLinN);
                  if ((mLinN mod 200) = 1) then SetLength(mLin, mLinN+199);   // 200m
                  with mLin[mLinN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     start_x     := x1 ;
                     start_y     := y1 ;
                     end_x       := x2 ;
                     end_y       := y2 ;
                  end;
                  Result := True ;
               except
                  Dec(mLinN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ܐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataLines(s:string;lay,col,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
var
   m,i : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (num <=0) then exit ;
   for i:=1 to num-1 do
      if (Abs(vx[i]-vx[i-1]) < LIMIT10)and(Abs(vy[i]-vy[i-1]) < LIMIT10) then exit ; // _

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,3,dLnsN)) then begin
         try
            Inc(dLnsN);
            if ((dLnsN mod 100) = 1) then SetLength(dLns, dLnsN+99);    // 100m
            with dLns[dLnsN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Number      := num ;
               SetLength(X, num);
               SetLength(Y, num);
               for i:=0 to num-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dLnsN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,3,mLnsN)) then begin
               try
                  Inc(mLnsN);
                  if ((mLnsN mod 100) = 1) then SetLength(mLns, mLnsN+99);    // 100m
                  with mLns[mLnsN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mLnsN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,3,mLnsN)) then begin
               try
                  Inc(mLnsN);
                  if ((mLnsN mod 100) = 1) then SetLength(mLns, mLnsN+99);    // 100m
                  with mLns[mLnsN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
               except
                  Dec(mLnsN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ~@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    cx : S_X
//    cy : S_Y
//    cr : a
// (ret) True:o^OK@False:NG
function TDataClass.AddDataCircle(s:string;lay,col,ltp,wid:integer;cx,cy,cr:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (cr < LIMIT10) then exit ;    // a <= 0

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,4,dCirN)) then begin
         try
            Inc(dCirN);
            if ((dCirN mod 200) = 1) then SetLength(dCir, dCirN+199);   // 200m
            with dCir[dCirN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dCirN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,4,mCirN)) then begin
               try
                  Inc(mCirN);
                  if ((mCirN mod 200) = 1) then SetLength(mCir, mCirN+199);   // 200m
                  with mCir[mCirN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mCirN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,4,mCirN)) then begin
               try
                  Inc(mCirN);
                  if ((mCirN mod 200) = 1) then SetLength(mCir, mCirN+199);   // 200m
                  with mCir[mCirN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                  end;
                  Result := True ;
               except
                  Dec(mCirN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ~ʁ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddDataArc(s:string;lay,col,ltp,wid,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (cr < LIMIT10) then exit ;          // a <= 0
   if (dir <> 0) then dir := 1 ;
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,5,dArcN)) then begin
         try
            Inc(dArcN);
            if ((dArcN mod 200) = 1) then SetLength(dArc, dArcN+199);   // 200m
            with dArc[dArcN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
               Direction   := dir ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dArcN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,5,mArcN)) then begin
               try
                  Inc(mArcN);
                  if ((mArcN mod 200) = 1) then SetLength(mArc, mArcN+199);   // 200m
                  with mArc[mArcN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                     Direction   := dir ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mArcN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,5,mArcN)) then begin
               try
                  Inc(mArcN);
                  if ((mArcN mod 200) = 1) then SetLength(mArc, mArcN+199);   // 200m
                  with mArc[mArcN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                     Direction   := dir ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  Result := True ;
               except
                  Dec(mArcN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ȉ~@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
// (ret) True:o^OK@False:NG
function TDataClass.AddDataEllipse(s:string;lay,col,ltp,wid:integer;cx,cy,rx,ry,ra:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   ra := SetAngle(ra);

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,6,dEllN)) then begin
         try
            Inc(dEllN);
            if ((dEllN mod 200) = 1) then SetLength(dEll, dEllN+199);   // 200m
            with dEll[dEllN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               rotation_angle := ra ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dEllN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,6,mEllN)) then begin
               try
                  Inc(mEllN);
                  if ((mEllN mod 200) = 1) then SetLength(mEll, mEllN+199);   // 200m
                  with mEll[mEllN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     rotation_angle := ra ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mEllN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,6,mEllN)) then begin
               try
                  Inc(mEllN);
                  if ((mEllN mod 200) = 1) then SetLength(mEll, mEllN+199);   // 200m
                  with mEll[mEllN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     rotation_angle := ra ;
                  end;
                  Result := True ;
               except
                  Dec(mEllN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ȉ~ʁ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddDataEllipseArc(s:string;lay,col,ltp,wid,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   if (dir <> 0) then dir := 1 ;
   ra := SetAngle(ra);
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,7,dEArN)) then begin
         try
            Inc(dEArN);
            if ((dEArN mod 200) = 1) then SetLength(dEAr, dEArN+199);   // 200m
            with dEAr[dEArN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               Direction   := dir ;
               rotation_angle := ra ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dEArN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,7,mEArN)) then begin
               try
                  Inc(mEArN);
                  if ((mEArN mod 200) = 1) then SetLength(mEAr, mEArN+199);   // 200m
                  with mEAr[mEArN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     Direction   := dir ;
                     rotation_angle := ra ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mEArN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,7,mEArN)) then begin
               try
                  Inc(mEArN);
                  if ((mEArN mod 200) = 1) then SetLength(mEAr, mEArN+199);   // 200m
                  with mEAr[mEArN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     Direction   := dir ;
                     rotation_angle := ra ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  Result := True ;
               except
                  Dec(mEArN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    str: 
//    lay: C(1-256)
//    col: F@    (0,1-256)
//    fon: tHg(0,1-1024)
//    bp : _(1-9)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    ph : ͈͍
//    pw : ͈͕
//    ps : Ԋu
//    an : ]p
//    sl : Xgp
// (ret) True:o^OK@False:NG
function TDataClass.AddDataText(s,st:string;lay,col,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if not(StrCheck(st)) then exit;                 // 񐔃`FbN
   if (ph < LIMIT10)or(pw < LIMIT10) then exit ;   // ͈͂ <= 0
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 1 ;
   if (dir <> 1) then dir := 2 ;
   if (ps < 0.0) then ps := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,8,dTxtN)) then begin
         try
            Inc(dTxtN);
            if ((dTxtN mod 200) = 1) then SetLength(dTxt, dTxtN+199);   // 200m
            with dTxt[dTxtN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Font        := fnt ;
               str         := st ;
               text_x      := px ;
               text_y      := py ;
               Height      := ph ;
               Width       := pw ;
               Spc         := ps ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,-1,-1,fnt);
         except
            Dec(dTxtN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,8,mTxtN)) then begin
               try
                  Inc(mTxtN);
                  if ((mTxtN mod 200) = 1) then SetLength(mTxt, mTxtN+199);   // 200m
                  with mTxt[mTxtN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Height      := ph ;
                     Width       := pw ;
                     Spc         := ps ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,-1,-1,fnt);
               except
                  Dec(mTxtN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,8,mTxtN)) then begin
               try
                  Inc(mTxtN);
                  if ((mTxtN mod 200) = 1) then SetLength(mTxt, mTxtN+199);   // 200m
                  with mTxt[mTxtN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Height      := ph ;
                     Width       := pw ;
                     Spc         := ps ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  Result := True ;
               except
                  Dec(mTxtN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// xWFȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataBezier(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
var
   m,i : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if ( ((num-1)mod 3) > 0) then num := ((num-1) div 3)*3+1;
   if (num <= 1) then exit ;
   for i:=1 to num-1 do
      if (((i-2) mod 3) > 0)
       and(Abs(vx[i]-vx[i-1]) < LIMIT10)
       and(Abs(vy[i]-vy[i-1]) < LIMIT10) then exit ;  // _i_1Ɛ_2͓ł\Ȃj
   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,9,dBezN)) then begin
         try
            Inc(dBezN);
            if ((dBezN mod 100) = 1) then SetLength(dBez, dBezN+99);    // 100m
            with dBez[dBezN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               SetLength(X, num);
               SetLength(Y, num);
               for i:=0 to num-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dBezN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,9,mBezN)) then begin
               try
                  Inc(mBezN);
                  if ((mBezN mod 100) = 1) then SetLength(mBez, mBezN+99);    // 100m
                  with mBez[mBezN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mBezN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,9,mBezN)) then begin
               try
                  Inc(mBezN);
                  if ((mBezN mod 100) = 1) then SetLength(mBez, mBezN+99);    // 100m
                  with mBez[mBezN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
               except
                  Dec(mBezN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// aXvCȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataBspline(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
var
   m,i : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   for i:=1 to num-1 do
      if (Abs(vx[i]-vx[i-1]) < LIMIT10)
      and(Abs(vy[i]-vy[i-1]) < LIMIT10) then exit ;   // _
   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,10,dBspN)) then begin
         try
            Inc(dBspN);
            if ((dBspN mod 100) = 1) then SetLength(dBsp, dBspN+99);    // 100m
            with dBsp[dBspN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               SetLength(X, num);
               SetLength(Y, num);
               for i:=0 to num-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dBspN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,10,mBspN)) then begin
               try
                  Inc(mBspN);
                  if ((mBspN mod 100) = 1) then SetLength(mBsp, mBspN+99);    // 100m
                  with mBsp[mBspN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mBspN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,10,mBspN)) then begin
               try
                  Inc(mBspN);
                  if ((mBspN mod 100) = 1) then SetLength(mBsp, mBspN+99);    // 100m
                  with mBsp[mBspN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
               except
                  Dec(mBspN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// XvCȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    stp: Ȑ^Cv (1:CXvC 2:xWF)
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataSpline(s:string;lay,col,ltp,wid,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
var
   m,i : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (stp < 1) or (stp > 3)     then stp := 1 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   for i:=1 to num-1 do
      if (Abs(vx[i]-vx[i-1]) < LIMIT10)
      and(Abs(vy[i]-vy[i-1]) < LIMIT10) then exit ;   // _
   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,11,dSplN)) then begin
         try
            Inc(dSplN);
            if ((dSplN mod 100) = 1) then SetLength(dSpl, dSplN+99);    // 100m
            with dSpl[dSplN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Stype       := stp ;
               Aval        := av ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               SetLength(X, num);
               SetLength(Y, num);
               for i:=0 to num-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dSplN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,11,mSplN)) then begin
               try
                  Inc(mSplN);
                  if ((mSplN mod 100) = 1) then SetLength(mSpl, mSplN+99);    // 100m
                  with mSpl[mSplN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Stype       := stp ;
                     Aval        := av ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mSplN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,11,mSplN)) then begin
               try
                  Inc(mSplN);
                  if ((mSplN mod 100) = 1) then SetLength(mSpl, mSplN+99);    // 100m
                  with mSpl[mSplN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Stype       := stp ;
                     Aval        := av ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     SetLength(X, num);
                     SetLength(Y, num);
                     for i:=0 to num-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
               except
                  Dec(mSplN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// N\ChȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    dir: @(0:v,1:v)
//@@sp : 
//    bx : zu_wW
//    by : zu_xW
//    av : p[^@N\Cĥ`l(0)
//    an : ]p[]
//    l1 : JnȐ (0ȏ) ȐƂĂ̓}CiXl\łSXFdl0ȏƌ܂Ă̂Ő
//    l2 : IȐ (0ȏ)
// (ret) True:o^OK@False:NG
function TDataClass.AddDataClothoid(s:string;lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayN) then lay := 1 ;
   if (col < 0) or (col > zColN) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpN) then ltp := 0 ;
   if (wid < 0) or (wid > zWidN) then wid := 0 ;
   if (dir <> 0) then dir := 1 ;
   if (sp <     1) then sp := 1 ;
   if (sp > 10000) then sp := 10000 ;
   if (av <= 0.0) then exit ;             // p[^Al 0
   an := SetAngle(an);
   if (l1 < 0.0) then l1 := 0.0 ;
   if (l2 < 0.0) then l2 := 0.0 ;
   if (Abs(l1-l2) < LIMIT10) then exit ;  // Jn = I

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,12,dCloN)) then begin
         try
            Inc(dCloN);
            if ((dCloN mod 100) = 1) then SetLength(dClo, dCloN+99);    // 100m
            with dClo[dCloN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               base_x      := bx ;
               base_y      := by ;
               Aval        := av ;
               Direction   := dir ;
               Angle       := an ;
               start_length:= l1 ;
               end_length  := l2 ;
               sep         := sp ;
            end;
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dCloN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddDataOrder(m,12,mCloN)) then begin
               try
                  Inc(mCloN);
                  if ((mCloN mod 100) = 1) then SetLength(mClo, mCloN+99);    // 100m
                  with mClo[mCloN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     base_x      := bx ;
                     base_y      := by ;
                     Aval        := av ;
                     Direction   := dir ;
                     Angle       := an ;
                     start_length:= l1 ;
                     end_length  := l2 ;
                     sep         := sp ;
                  end;
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mCloN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            if (AddDataOrder(m,12,mCloN)) then begin
               try
                  Inc(mCloN);
                  if ((mCloN mod 100) = 1) then SetLength(mClo, mCloN+99);    // 100m
                  with mClo[mCloN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     base_x      := bx ;
                     base_y      := by ;
                     Aval        := av ;
                     Direction   := dir ;
                     Angle       := an ;
                     start_length:= l1 ;
                     end_length  := l2 ;
                     sep         := sp ;
                  end;
                  Result := True ;
               except
                  Dec(mCloN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

end.
